diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/SystemConfigService.java b/base/common/src/com/netscape/cms/servlet/csadmin/SystemConfigService.java
index 4304f5bf0236a5a49b2cd018c91ed35da7b21da4..ce82c93489d3dbe273ebf7e2dbff57105671f533 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/SystemConfigService.java
+++ b/base/common/src/com/netscape/cms/servlet/csadmin/SystemConfigService.java
@@ -753,6 +514,403 @@ public class SystemConfigService extends PKIService implements SystemConfigResou
         return response;
     }
 
+    private void authdbPanel(ConfigurationRequest data) {
+        cs.putString("auths.instance.ldap1.ldap.basedn", data.getAuthdbBaseDN());
+        cs.putString("auths.instance.ldap1.ldap.ldapconn.host", data.getAuthdbHost());
+        cs.putString("auths.instance.ldap1.ldap.ldapconn.port", data.getAuthdbPort());
+        cs.putString("auths.instance.ldap1.ldap.ldapconn.secureConn", data.getAuthdbSecureConn());
+    }
+
+    private void caInfoPanel(ConfigurationRequest data, String subsystemNick) {
+        URI caUri = null;
+        try {
+            caUri = new URI(data.getCaUri());
+        } catch (URISyntaxException e) {
+            throw new BadRequestException("Invalid caURI " + caUri);
+        }
+        cs.putString("preop.cainfo.select", data.getCaUri());
+        cs.putString("conn.ca1.clientNickname", subsystemNick);
+        cs.putString("conn.ca1.hostport", caUri.getHost() + ":" + caUri.getPort());
+        cs.putString("conn.ca1.hostagentport", caUri.getHost() + ":" + caUri.getPort());
+        cs.putString("conn.ca1.hostadminport", caUri.getHost() + ":" + caUri.getPort());
+    }
+
+    private void tksInfoPanel(ConfigurationRequest data, String subsystemNick) {
+        URI tksUri = null;
+        try {
+            tksUri = new URI(data.getTksUri());
+        } catch (URISyntaxException e) {
+            throw new BadRequestException("Invalid tksURI " + tksUri);
+        }
+        cs.putString("preop.tksinfo.select", data.getTksUri());
+        cs.putString("conn.tks1.clientNickname", subsystemNick);
+        cs.putString("conn.tks1.hostport", tksUri.getHost() + ":" + tksUri.getPort());
+    }
+
+    private void kraInfoPanel(ConfigurationRequest data, String subsystemNick) {
+        if (data.getEnableServerSideKeyGen().equalsIgnoreCase("true")) {
+            URI kraUri = null;
+            try {
+                kraUri = new URI(data.getCaUri());
+            } catch (URISyntaxException e) {
+                throw new BadRequestException("Invalid kraURI " + kraUri);
+            }
+            cs.putString("preop.krainfo.select", data.getKraUri());
+            cs.putString("conn.drm1.clientNickname", subsystemNick);
+            cs.putString("conn.drm1.hostport", kraUri.getHost() + ":" + kraUri.getPort());
+            cs.putString("conn.tks1.serverKeygen", "true");
+            cs.putString("op.enroll.userKey.keyGen.encryption.serverKeygen.enable", "true");
+            cs.putString("op.enroll.userKeyTemporary.keyGen.encryption.serverKeygen.enable", "true");
+            cs.putString("op.enroll.soKey.keyGen.encryption.serverKeygen.enable", "true");
+            cs.putString("op.enroll.soKeyTemporary.keyGen.encryption.serverKeygen.enable", "true");
+        } else {
+            // no keygen
+            cs.putString("conn.tks1.serverKeygen", "false");
+            cs.putString("op.enroll.userKey.keyGen.encryption.serverKeygen.enable", "false");
+            cs.putString("op.enroll.userKeyTemporary.keyGen.encryption.serverKeygen.enable", "false");
+            cs.putString("op.enroll.userKey.keyGen.encryption.recovery.destroyed.scheme", "GenerateNewKey");
+            cs.putString("op.enroll.userKeyTemporary.keyGen.encryption.recovery.onHold.scheme", "GenerateNewKey");
+            cs.putString("conn.drm1.clientNickname", "");
+            cs.putString("conn.drm1.hostport", "");
+            cs.putString("op.enroll.soKey.keyGen.encryption.serverKeygen.enable", "false");
+            cs.putString("op.enroll.soKeyTemporary.keyGen.encryption.serverKeygen.enable", "false");
+            cs.putString("op.enroll.soKey.keyGen.encryption.recovery.destroyed.scheme", "GenerateNewKey");
+            cs.putString("op.enroll.soKeyTemporary.keyGen.encryption.recovery.onHold.scheme", "GenerateNewKey");
+        }
+    }
+
+    private void adminPanel(ConfigurationRequest data, ConfigurationResponse response) {
+        if (!data.getIsClone().equals("true")) {
+            try {
+                X509CertImpl admincerts[] = new X509CertImpl[1];
+                ConfigurationUtils.createAdmin(data.getAdminUID(), data.getAdminEmail(),
+                        data.getAdminName(), data.getAdminPassword());
+                if (data.getImportAdminCert().equalsIgnoreCase("true")) {
+                    String b64 = CryptoUtil.stripCertBrackets(data.getAdminCert().trim());
+                    byte[] b = CryptoUtil.base64Decode(b64);
+                    admincerts[0] = new X509CertImpl(b);
+                } else {
+                    if (csType.equals("CA")) {
+                        ConfigurationUtils.createAdminCertificate(data.getAdminCertRequest(),
+                                data.getAdminCertRequestType(), data.getAdminSubjectDN());
+
+                        String serialno = cs.getString("preop.admincert.serialno.0");
+                        ICertificateAuthority ca = (ICertificateAuthority) CMS.getSubsystem(ICertificateAuthority.ID);
+                        ICertificateRepository repo = ca.getCertificateRepository();
+                        admincerts[0] = repo.getX509Certificate(new BigInteger(serialno, 16));
+                    } else {
+                        String type = cs.getString("preop.ca.type", "");
+                        String ca_hostname = "";
+                        int ca_port = -1;
+                        if (type.equals("sdca")) {
+                            ca_hostname = cs.getString("preop.ca.hostname");
+                            ca_port = cs.getInteger("preop.ca.httpsport");
+                        } else {
+                            ca_hostname = cs.getString("securitydomain.host", "");
+                            ca_port = cs.getInteger("securitydomain.httpseeport");
+                        }
+                        String b64 = ConfigurationUtils.submitAdminCertRequest(ca_hostname, ca_port,
+                                data.getAdminProfileID(), data.getAdminCertRequestType(),
+                                data.getAdminCertRequest(), data.getAdminSubjectDN());
+                        b64 = CryptoUtil.stripCertBrackets(b64.trim());
+                        byte[] b = CryptoUtil.base64Decode(b64);
+                        admincerts[0] = new X509CertImpl(b);
+                    }
+                }
+                CMS.reinit(IUGSubsystem.ID);
+
+                IUGSubsystem ug = (IUGSubsystem) CMS.getSubsystem(IUGSubsystem.ID);
+                IUser user = ug.getUser(data.getAdminUID());
+                user.setX509Certificates(admincerts);
+                ug.addUserCert(user);
+                response.setAdminCert(admincerts[0]);
+
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Error in creating admin user: " + e);
+            }
+        }
+    }
+
+    private void databasePanel(ConfigurationRequest data) {
+        cs.putString("internaldb.ldapconn.host", data.getDsHost());
+        cs.putString("internaldb.ldapconn.port", data.getDsPort());
+        cs.putString("internaldb.database", data.getDatabase());
+        cs.putString("internaldb.basedn", data.getBaseDN());
+        cs.putString("internaldb.ldapauth.bindDN", data.getBindDN());
+        cs.putString("internaldb.ldapconn.secureConn", (data.getSecureConn().equals("on") ? "true" : "false"));
+        cs.putString("preop.database.removeData", data.getRemoveData());
+
+        if (csType.equals("TPS")) {
+            cs.putString("tokendb.activityBaseDN", "ou=Activities," + data.getBaseDN());
+            cs.putString("tokendb.baseDN", "ou=Tokens," + data.getBaseDN());
+            cs.putString("tokendb.certBaseDN", "ou=Certificates," + data.getBaseDN());
+            cs.putString("tokendb.userBaseDN", data.getBaseDN());
+            cs.putString("tokendb.hostport", data.getDsHost() + ":" + data.getDsPort());
+        }
+
+        try {
+            cs.commit(false);
+        } catch (EBaseException e2) {
+            e2.printStackTrace();
+            throw new PKIException("Unable to commit config parameters to file");
+        }
+
+        if (data.getIsClone().equals("true")) {
+            String masterhost = "";
+            String masterport = "";
+            String masterbasedn = "";
+            String realhostname = "";
+            try {
+                masterhost = cs.getString("preop.internaldb.master.ldapconn.host", "");
+                masterport = cs.getString("preop.internaldb.master.ldapconn.port", "");
+                masterbasedn = cs.getString("preop.internaldb.master.basedn", "");
+                realhostname = cs.getString("machineName", "");
+            } catch (Exception e) {
+            }
+
+            if (masterhost.equals(realhostname) && masterport.equals(data.getDsPort())) {
+                throw new BadRequestException("Master and clone must not share the same internal database");
+            }
+
+            if (!masterbasedn.equals(data.getBaseDN())) {
+                throw new BadRequestException("Master and clone should have the same base DN");
+            }
+
+            String masterReplicationPort = data.getMasterReplicationPort();
+            if ((masterReplicationPort != null) && (!masterReplicationPort.equals(""))) {
+                cs.putString("internaldb.ldapconn.masterReplicationPort", masterReplicationPort);
+            } else {
+                cs.putString("internaldb.ldapconn.masterReplicationPort", masterport);
+            }
+
+            String cloneReplicationPort = data.getCloneReplicationPort();
+            if ((cloneReplicationPort == null) || (cloneReplicationPort.length() == 0)) {
+                cloneReplicationPort = data.getDsPort();
+            }
+            cs.putString("internaldb.ldapconn.cloneReplicationPort", cloneReplicationPort);
+
+            String replicationSecurity = data.getReplicationSecurity();
+            if ((cloneReplicationPort == data.getDsPort()) && (data.getSecureConn().equals("on"))) {
+                replicationSecurity = "SSL";
+            } else if (replicationSecurity == null) {
+                replicationSecurity = "None";
+            }
+            cs.putString("internaldb.ldapconn.replicationSecurity", replicationSecurity);
+
+            cs.putString("preop.internaldb.replicateSchema", data.getReplicateSchema());
+        }
+
+        try {
+            /* BZ 430745 create password for replication manager */
+            String replicationpwd = Integer.toString(new Random().nextInt());
+
+            IConfigStore psStore = null;
+            String passwordFile = null;
+            passwordFile = cs.getString("passwordFile");
+            psStore = CMS.createFileConfigStore(passwordFile);
+            psStore.putString("internaldb", data.getBindpwd());
+            psStore.putString("replicationdb", replicationpwd);
+            psStore.commit(false);
+
+            if (data.getStepTwo() == null) {
+                ConfigurationUtils.populateDB();
+
+                cs.putString("preop.internaldb.replicationpwd", replicationpwd);
+                cs.putString("preop.database.removeData", "false");
+                cs.commit(false);
+
+                if (data.getIsClone().equals("true")) {
+                    CMS.debug("Start setting up replication.");
+                    ConfigurationUtils.setupReplication();
+                }
+
+                ConfigurationUtils.reInitSubsystem(csType);
+                ConfigurationUtils.populateDBManager();
+                ConfigurationUtils.populateVLVIndexes();
+            }
+        } catch (Exception e) {
+            throw new PKIException("Error in populating database" + e);
+        }
+    }
+
+    private void hierarchyPanel(ConfigurationRequest data) {
+        if (csType.equals("CA") && data.getIsClone().equals("false")) {
+            if (data.getHierarchy().equals("root")) {
+                cs.putString("preop.hierarchy.select", "root");
+                cs.putString("hierarchy.select", "Root");
+                cs.putString("preop.ca.type", "sdca");
+            } else if (data.getHierarchy().equals("join")) {
+                cs.putString("preop.cert.signing.type", "remote");
+                cs.putString("preop.hierarchy.select", "join");
+                cs.putString("hierarchy.select", "Subordinate");
+            } else {
+                throw new BadRequestException("Invalid hierarchy provided");
+            }
+        }
+    }
+
+    private void getCloningData(ConfigurationRequest data, String certList, String token, String domainXML) {
+        StringTokenizer t = new StringTokenizer(certList, ",");
+        while (t.hasMoreTokens()) {
+            String tag = t.nextToken();
+            if (tag.equals("sslserver")) {
+                cs.putBoolean("preop.cert." + tag + ".enable", true);
+            } else {
+                cs.putBoolean("preop.cert." + tag + ".enable", false);
+            }
+        }
+
+        String cloneUri = data.getCloneUri();
+        URL url = null;
+        try {
+            url = new URL(cloneUri);
+        } catch (MalformedURLException e) {
+            // should not reach here as this check is done in validate()
+        }
+        String masterHost = url.getHost();
+        int masterPort = url.getPort();
+
+        // check and store cloneURI information
+        boolean validCloneUri;
+        try {
+            validCloneUri = ConfigurationUtils.isValidCloneURI(domainXML, masterHost, masterPort);
+        } catch (Exception e) {
+            e.printStackTrace();
+            throw new PKIException("Error in determining whether clone URI is valid");
+        }
+
+        if (!validCloneUri) {
+            throw new BadRequestException(
+                    "Invalid clone URI provided.  Does not match the available subsystems in the security domain");
+        }
+
+        if (csType.equals("CA")) {
+            try {
+                int masterAdminPort = ConfigurationUtils.getPortFromSecurityDomain(domainXML,
+                        masterHost, masterPort, "CA", "SecurePort", "SecureAdminPort");
+                ConfigurationUtils.importCertChain(masterHost, masterAdminPort, "/ca/admin/ca/getCertChain",
+                        "clone");
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Failed to import certificate chain from master" + e);
+            }
+        }
+
+        try {
+            ConfigurationUtils.getConfigEntriesFromMaster();
+        } catch (Exception e) {
+            e.printStackTrace();
+            throw new PKIException("Failed to obtain configuration entries from the master for cloning " + e);
+        }
+
+        // restore certs from P12 file
+        if (token.equals(ConfigurationRequest.TOKEN_DEFAULT)) {
+            String p12File = data.getP12File();
+            String p12Pass = data.getP12Password();
+            try {
+                ConfigurationUtils.restoreCertsFromP12(p12File, p12Pass);
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Failed to restore certificates from p12 file" + e);
+            }
+        }
+
+        boolean cloneReady = ConfigurationUtils.isCertdbCloned();
+        if (!cloneReady) {
+            CMS.debug("clone does not have all the certificates.");
+            throw new PKIException("Clone does not have all the required certificates");
+        }
+    }
+
+    private String securityDomainPanel(ConfigurationRequest data, String securityDomainType) {
+        String domainXML = null;
+        String securityDomainName = data.getSecurityDomainName();
+        String securityDomainURL = data.getSecurityDomainUri();
+
+        if (securityDomainType.equals(ConfigurationRequest.NEW_DOMAIN)) {
+            cs.putString("preop.securitydomain.select", "new");
+            cs.putString("securitydomain.select", "new");
+            cs.putString("preop.securitydomain.name", securityDomainName);
+            cs.putString("securitydomain.name", securityDomainName);
+            cs.putString("securitydomain.host", CMS.getEENonSSLHost());
+            cs.putString("securitydomain.httpport", CMS.getEENonSSLPort());
+            cs.putString("securitydomain.httpsagentport", CMS.getAgentPort());
+            cs.putString("securitydomain.httpseeport", CMS.getEESSLPort());
+            cs.putString("securitydomain.httpsadminport", CMS.getAdminPort());
+            cs.putString("preop.cert.subsystem.type", "local");
+            cs.putString("preop.cert.subsystem.profile", "subsystemCert.profile");
+        } else {
+            cs.putString("preop.securitydomain.select", "existing");
+            cs.putString("securitydomain.select", "existing");
+            cs.putString("preop.cert.subsystem.type", "remote");
+            cs.putString("preop.cert.subsystem.profile", "caInternalAuthSubsystemCert");
+
+            // contact and log onto security domain
+            URL secdomainURL;
+            String host;
+            int port;
+            try {
+                secdomainURL = new URL(securityDomainURL);
+                host = secdomainURL.getHost();
+                port = secdomainURL.getPort();
+                cs.putString("securitydomain.host", host);
+                cs.putInteger("securitydomain.httpsadminport",port);
+                ConfigurationUtils.importCertChain(host, port, "/ca/admin/ca/getCertChain", "securitydomain");
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Failed to import certificate chain from security domain master: " + e);
+            }
+
+            // log onto security domain and get token
+            String user = data.getSecurityDomainUser();
+            String pass = data.getSecurityDomainPassword();
+            String installToken;
+            try {
+                installToken = ConfigurationUtils.getInstallToken(host, port, user, pass);
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Failed to obtain installation token from security domain: " + e);
+            }
+
+            if (installToken == null) {
+                throw new PKIException("Failed to obtain installation token from security domain");
+            }
+            CMS.setConfigSDSessionId(installToken);
+
+            try {
+                domainXML = ConfigurationUtils.getDomainXML(host, port, true);
+                ConfigurationUtils.getSecurityDomainPorts(domainXML, host, port);
+            } catch (Exception e) {
+                e.printStackTrace();
+                throw new PKIException("Failed to obtain security domain decriptor from security domain master: " + e);
+            }
+        }
+        return domainXML;
+    }
+
+    private void tokenPanel(ConfigurationRequest data, String token) {
+        cs.putString("preop.module.token", token);
+
+        if (! token.equals(ConfigurationRequest.TOKEN_DEFAULT)) {
+            try {
+                CryptoManager cryptoManager = CryptoManager.getInstance();
+                CryptoToken ctoken = cryptoManager.getTokenByName(token);
+                String tokenpwd = data.getTokenPassword();
+                ConfigurationUtils.loginToken(ctoken, tokenpwd);
+            } catch (NotInitializedException e) {
+                throw new PKIException("Token is not initialized");
+            } catch (NoSuchTokenException e) {
+                throw new BadRequestException("Invalid Token provided. No such token.");
+            } catch (TokenException e) {
+                e.printStackTrace();
+                throw new PKIException("Token Exception" + e);
+            } catch (IncorrectPasswordException e) {
+                throw new BadRequestException("Incorrect Password provided for token.");
+            }
+        }
+    }
+
     private void validateData(ConfigurationRequest data) {
         // get required info from CS.cfg
         String preopPin;
@@ -946,5 +1104,60 @@ public class SystemConfigService extends PKIService implements SystemConfigResou
         if (data.getGenerateServerCert() == null) {
             data.setGenerateServerCert("true");
         }
+
+        if (csType.equals("TPS")) {
+            if ((data.getCaUri() == null) || data.getCaUri().isEmpty()) {
+                throw new BadRequestException("CA URI not provided");
+            }
+            try {
+                @SuppressWarnings("unused")
+                URI ca_uri = new URI(data.getCaUri());
+            } catch (URISyntaxException e) {
+                throw new BadRequestException("Invalid CA URI");
+            }
+
+            if ((data.getTksUri() == null) || data.getTksUri().isEmpty()) {
+                throw new BadRequestException("TKS URI not provided");
+            }
+            try {
+                @SuppressWarnings("unused")
+                URI tks_uri = new URI(data.getTksUri());
+            } catch (URISyntaxException e) {
+                throw new BadRequestException("Invalid TKS URI");
+            }
+
+            if (data.getEnableServerSideKeyGen().equalsIgnoreCase("true")) {
+                if ((data.getKraUri() == null) || data.getKraUri().isEmpty()) {
+                    throw new BadRequestException("KRA URI required if server-side key generation requested");
+                }
+                try {
+                    @SuppressWarnings("unused")
+                    URI kra_uri = new URI(data.getKraUri());
+                } catch (URISyntaxException e) {
+                    throw new BadRequestException("Invalid KRA URI");
+                }
+            }
+
+            if ((data.getAuthdbBaseDN()==null) || data.getAuthdbBaseDN().isEmpty()) {
+                throw new BadRequestException("Authentication Database baseDN not provided");
+            }
+            if ((data.getAuthdbHost()==null) || data.getAuthdbHost().isEmpty()) {
+                throw new BadRequestException("Authentication Database hostname not provided");
+            }
+            if ((data.getAuthdbPort()==null) || data.getAuthdbPort().isEmpty()) {
+                throw new BadRequestException("Authentication Database port not provided");
+            }
+            if ((data.getAuthdbSecureConn()==null) || data.getAuthdbSecureConn().isEmpty()) {
+                throw new BadRequestException("Authentication Database secure conn not provided");
+            }
+
+            try {
+                Integer.parseInt(data.getAuthdbPort()); // check for errors
+            } catch (NumberFormatException e) {
+                throw new BadRequestException("Authdb port is invalid");
+            }
+
+            // TODO check connection with authdb
+        }
     }
 }
diff --git a/base/kra/shared/conf/CS.cfg.in b/base/kra/shared/conf/CS.cfg.in
index 48d285d6ad0ca56864b36d4675158da78eff6b47..98d8757a644db0035f4fee311881d72209737cee 100644
--- a/base/kra/shared/conf/CS.cfg.in
+++ b/base/kra/shared/conf/CS.cfg.in
@@ -40,7 +40,7 @@ service.non_clientauth_securePort=[PKI_EE_SECURE_PORT]
 service.unsecurePort=[PKI_UNSECURE_PORT]
 service.instanceID=[PKI_INSTANCE_NAME]
 preop.admin.name=Data Recovery Manager Administrator
-preop.admin.group=Data Recovery Manager Agents
+preop.admin.group=Data Recovery Manager Agents, Administrators
 preop.admincert.profile=caAdminCert
 preop.pin=[PKI_RANDOM_NUMBER]
 kra.cert.list=transport,storage,sslserver,subsystem,audit_signing
diff --git a/base/ocsp/shared/conf/CS.cfg.in b/base/ocsp/shared/conf/CS.cfg.in
index 25e4c9e9e77f588ec997f07b83f3e7167fd74c56..223e715c5a16d5c0335a49e1533a36ceaacf952b 100644
--- a/base/ocsp/shared/conf/CS.cfg.in
+++ b/base/ocsp/shared/conf/CS.cfg.in
@@ -20,7 +20,7 @@ cs.type=OCSP
 admin.interface.uri=ocsp/admin/console/config/wizard
 agent.interface.uri=ocsp/agent/ocsp
 preop.admin.name=Online Certificate Status Manager Administrator
-preop.admin.group=Online Certificate Status Manager Agents
+preop.admin.group=Online Certificate Status Manager Agents, Administrators
 preop.admincert.profile=caAdminCert
 preop.securitydomain.admin_url=https://[PKI_HOSTNAME]:9445
 preop.wizard.name=OCSP Setup Wizard
diff --git a/base/server/config/pkislots.cfg b/base/server/config/pkislots.cfg
index 8c521232025842896d74230a9580fea90572777e..6e13a89717a41c60c48aeef867e5b8127a62058d 100644
--- a/base/server/config/pkislots.cfg
+++ b/base/server/config/pkislots.cfg
@@ -26,7 +26,6 @@ SERVER_ROOT_SLOT=[SERVER_ROOT]
 SYSTEM_LIBRARIES_SLOT=[SYSTEM_LIBRARIES]
 SYSTEM_USER_LIBRARIES_SLOT=[SYSTEM_USER_LIBRARIES]
 TMP_DIR_SLOT=[TMP_DIR]
-TPS_DIR_SLOT=[TPS_DIR]
 [Tomcat]
 application_version=[APPLICATION_VERSION]
 INSTALL_TIME_SLOT=[INSTALL_TIME]
@@ -85,6 +84,9 @@ PKI_UNSECURE_PORT_SERVER_COMMENT_SLOT=[PKI_UNSECURE_PORT_SERVER_COMMENT]
 PKI_USER_SLOT=[PKI_USER]
 PKI_WEB_SERVER_TYPE_SLOT=[PKI_WEB_SERVER_TYPE]
 PKI_WEBAPPS_NAME_SLOT=[PKI_WEBAPPS_NAME]
+TOKENDB_HOST_SLOT=[TOKENDB_HOST]
+TOKENDB_PORT_SLOT={TOKENDB_PORT]
+TOKENDB_ROOT_SLOT=[TOKENDB_ROOT]
 TOMCAT_CFG_SLOT=[TOMCAT_CFG]
 TOMCAT_INSTANCE_COMMON_LIB_SLOT=[TOMCAT_INSTANCE_COMMON_LIB]
 TOMCAT_LOG_DIR_SLOT=[TOMCAT_LOG_DIR]
@@ -94,3 +96,4 @@ TOMCAT_SSL2_CIPHERS_SLOT=[TOMCAT_SSL2_CIPHERS]
 TOMCAT_SSL3_CIPHERS_SLOT=[TOMCAT_SSL3_CIPHERS]
 TOMCAT_SSL_OPTIONS_SLOT=[TOMCAT_SSL_OPTIONS]
 TOMCAT_TLS_CIPHERS_SLOT=[TOMCAT_TLS_CIPHERS]
+TPS_DIR_SLOT=[TPS_DIR]
diff --git a/base/server/etc/default.cfg b/base/server/etc/default.cfg
index b67b6670ecb7703fee659a9e21b108cdefffff41..facdf5f382c4c8eb7a0051e525454ab93032f6b0 100644
--- a/base/server/etc/default.cfg
+++ b/base/server/etc/default.cfg
@@ -138,6 +138,7 @@ pki_source_setup_path=/usr/share/pki/setup
 pki_source_server_path=/usr/share/pki/server/conf
 pki_source_cs_cfg=/usr/share/pki/%(pki_subsystem_type)s/conf/CS.cfg
 pki_source_registry=/usr/share/pki/setup/pkidaemon_registry
+pki_source_subsystem_path=/usr/share/pki/%(pki_subsystem_type)s
 pki_path=%(pki_root_prefix)s/var/lib/pki
 pki_log_path=%(pki_root_prefix)s/var/log/pki
 pki_configuration_path=%(pki_root_prefix)s/etc/pki
@@ -541,6 +542,13 @@ pki_ds_hostname=%(pki_hostname)s
 pki_subsystem_name=TPS %(pki_hostname)s %(pki_https_port)s
 pki_subsystem_nickname=subsystemCert cert-%(pki_instance_name)s TPS
 pki_subsystem_subject_dn=cn=TPS Subsystem Certificate,o=%(pki_security_domain_name)s
+pki_authdb_hostname=%(pki_hostname)s
+pki_authdb_port=389
+pki_authdb_secure_conn=False
+pki_ca_uri=https://%(pki_hostname)s:%(pki_https_port)s
+pki_kra_uri=https://%(pki_hostname)s:%(pki_https_port)s
+pki_tks_uri=https://%(pki_hostname)s:%(pki_https_port)s
+pki_enable_server_side_keygen=False
 
 # Paths
 # These are used in the processing of pkispawn and are not supposed
diff --git a/base/server/python/pki/server/deployment/pkihelper.py b/base/server/python/pki/server/deployment/pkihelper.py
index 6d47a902bb589c5ccccf0433233f042e0d7dd02e..349e9f41a82bb72f2b3d20bf6b75236d8b0c3944 100644
--- a/base/server/python/pki/server/deployment/pkihelper.py
+++ b/base/server/python/pki/server/deployment/pkihelper.py
@@ -3203,7 +3203,7 @@ class ConfigClient:
                              extra=config.PKI_INDENTATION_LEVEL_2)
 
         data = pki.system.ConfigurationRequest()
-
+         
         # Miscellaneous Configuration Information
         data.pin = self.master_dict['pki_one_time_pin']
         data.subsystemName = self.master_dict['pki_subsystem_name']
@@ -3247,6 +3247,10 @@ class ConfigClient:
 
         # Create system certs
         self.set_system_certs(data)
+        
+        # TPS parameters
+        if self.master_dict['pki_subsystem'] == "TPS":
+            self.set_tps_parameters(data)
 
         return data
 
@@ -3460,6 +3464,18 @@ class ConfigClient:
                config.str2bool(self.master_dict['pki_external_step_two']):
                 # External CA Step 2
                 data.stepTwo = "true"
+                
+    def set_tps_parameters(self, data):
+        data.caUri = self.master_dict['pki_ca_uri']
+        data.tksUri = self.master_dict['pki_tks_uri']
+        data.enableServerSideKeyGen = self.master_dict['pki_enable_server_side_keygen']
+        if config.str2bool(self.master_dict['pki_enable_server_side_keygen']):
+            data.kraUri = self.master_dict['pki_kra_uri']
+        data.authdbHost = self.master_dict['pki_authdb_hostname']
+        data.authdbPort = self.master_dict['pki_authdb_port']
+        data.authdbBaseDN = self.master_dict['pki_authdb_basedn']
+        data.authdbSecureConn = self.master_dict['pki_authdb_secure_conn']        
+        
 
     def create_system_cert(self, tag):
         cert = pki.system.SystemCertData()
diff --git a/base/server/python/pki/server/deployment/pkiparser.py b/base/server/python/pki/server/deployment/pkiparser.py
index be502bc019d1b12bea7b0dfaa05097f866237c10..a7337c81f42924ef53f19b25891835e49e646100 100644
--- a/base/server/python/pki/server/deployment/pkiparser.py
+++ b/base/server/python/pki/server/deployment/pkiparser.py
@@ -634,7 +634,6 @@ class PKIConfigParser:
                 self.pki_master_dict['SYSTEM_LIBRARIES_SLOT'] = None
                 self.pki_master_dict['SYSTEM_USER_LIBRARIES_SLOT'] = None
                 self.pki_master_dict['TMP_DIR_SLOT'] = None
-                self.pki_master_dict['TPS_DIR_SLOT'] = None
             elif self.pki_master_dict['pki_subsystem'] in\
                  config.PKI_TOMCAT_SUBSYSTEMS:
                 self.pki_master_dict['INSTALL_TIME_SLOT'] = \
@@ -826,6 +825,24 @@ class PKIConfigParser:
                     "+TLS_DHE_RSA_WITH_3DES_EDE_CBC_SHA," + \
                     "+TLS_DHE_RSA_WITH_AES_128_CBC_SHA," + \
                     "+TLS_DHE_RSA_WITH_AES_256_CBC_SHA"
+                    
+                # tps parameters
+                self.pki_master_dict['TOKENDB_HOST_SLOT'] = \
+                    self.pki_master_dict['pki_ds_hostname']
+                    
+                if config.str2bool(self.pki_master_dict['pki_ds_secure_connection']):
+                    self.pki_master_dict['TOKENDB_PORT_SLOT'] = \
+                        self.pki_master_dict['pki_ds_ldaps_port']
+                else:
+                    self.pki_master_dict['TOKENDB_PORT_SLOT'] = \
+                        self.pki_master_dict['pki_ds_ldap_port']
+                        
+                self.pki_master_dict['TOKENDB_ROOT_SLOT'] = \
+                    self.pki_master_dict['pki_ds_base_dn']
+                                   
+                self.pki_master_dict['TPS_DIR_SLOT'] = \
+                    self.pki_master_dict['pki_source_subsystem_path']
+                    
                 if self.pki_master_dict['pki_subsystem'] == "CA":
                     self.pki_master_dict['PKI_ENABLE_RANDOM_SERIAL_NUMBERS'] = \
                         self.pki_master_dict\
